


/**
 * 数组转换为树状结构
 * @pk 主键
 * @pid 父ID
 * **/
Array.prototype.dj_toTreeArray = function(pk = 'id', pid = 'pid', children = 'children'){
  let array = this.dj_copy()
  let mapper = []
  if(!Array.isArray(array)) { return mapper }
  this.forEach(item => { delete item[children]; });
  let object = {};
  this.forEach(item => { object[item[pk]] = item; });
  this.forEach(item => {
    let parent = object[item[pid]];
    if(parent) {(parent[children] || (parent[children] = [])).push(item);} else {  mapper.push(item); }
  });
  return mapper;
}
/**
 * 树状结构数组的遍历
 * @pk 主键
 * @pid 父ID
 * **/
Array.prototype.dj_ergodicTreeArray = function( callbackBlock = Function,children = 'children'){
  for (let index = 0; index< this.length; index++){
    let object = this[index];
    let isRootNode = false;
    if (!object.hasOwnProperty(children)){ isRootNode = true; }
    callbackBlock(object,isRootNode);
    if (object.hasOwnProperty(children)){object[children].dj_ergodicTreeArray(callbackBlock,children)}
  }
}




/**
 * 通过节点ID获取整个家族对象
 * @return 返回家庭数组 不包含子家庭
 * **/
Array.prototype.dj_nodeFamilyById = function (id, pid = 'pid', children = 'children') {
  return dj_familyTree(this,id,pid,children)

}


/**
 * 获取家族辅助函数
 * @pk 主键
 * @pid 父ID
 * **/
function dj_familyTree(data,id = 0, pid = 'pid', children = 'children') {
  let dataSource = JSON.parse(JSON.stringify(data));
  let mapper = []
  let forFn = function (arr, id) {
    for (let i = 0; i < arr.length; i++) {
      let item = arr[i]
      if (item.id === id) {
        mapper.unshift(item)
        forFn(dataSource, item[pid])
        break
      } else {
        if (item[children]) {
          forFn(item[children], id)
        }
      }
    }
  }
  forFn(dataSource, id)
  return mapper
}




