import '../category/category+String'
export function dj_phoneValidator  (rule, value, callback){
  if (!value) {
    callback(new Error('手机号码不能为空'));
  }else {
    if (value.dj_check('phone')) {
      callback();
    }else {
      callback(new Error('手机号码格式不正确'));
    }
  }
}
export function dj_ArrayValidator  (rule, value, callback){
  if (value.length == 0){
    callback(new Error(rule.message));
  }else {
    callback();
  }
}

export function dj_NumberNoZeroValidator  (rule, value, callback) {
  if (value == 0){
    callback(new Error(rule.message));
  }else {
    callback();
  }
}
export function dj_NumberValidator (rule, value, callback) {
  if (!value.toString().dj_check('number') ){
    callback(new Error(rule.message));
  }else {
    callback();
  }
}
export function dj_PriceValidator (rule, value, callback) {
  if (!value.toString().dj_check('price')){
    callback(new Error(rule.message));
  }else {
    callback();
  }
}

export function dj_rulesStringBlur(tip='不能为空') {
  return { required: true, message: tip, trigger: 'blur' };
}
export function dj_rulesObjectChange(tip='不能为空') {
  return { required: true, message: tip, trigger: 'blur' };
}
export function dj_rulesStringChange(tip='不能为空') {
  return { required: true, message: tip, trigger: 'change' };
}
export function dj_rulesNumberNoZeroBlur(tip='不能为空') {
  return {required: true, validator: dj_NumberNoZeroValidator,message:tip, trigger: 'blur'};
}
export function dj_rulesNumberBlur(tip='不能为空') {
  return {required: true, validator: dj_NumberValidator,message:tip, trigger: 'blur'};
}
export function dj_rulesNumberChange(tip='不能为空') {
  return {required: true, validator: dj_NumberValidator,message:tip, trigger: 'change'};
}
export function dj_rulesPriceBlur(tip='不能为空') {
  return {required: true, validator: dj_PriceValidator,message:tip, trigger: 'blur'};
}
export function dj_rulesPhoneChange() {
  return { required: true, validator: dj_phoneValidator, trigger: 'blur' };
}
export function dj_rulesArray(tip='不能为空') {
  return { required: true, validator: dj_ArrayValidator,message: tip, trigger: 'blur' };
}
